/*
    N = lungimea
    Sirul il formez din mai multe bucati de lungime care i le dau eu
    O bucata de lungime len contine o subsecventa de lungime cel putin K
    vezi explicatii si la functii
*/

#include <cstdio>
#include <cstdlib>
#include <time.h>
#include <memory.h>
#include <sstream>
using namespace std;

#define MAXN 1000100

int N, A[MAXN];
int B[MAXN];

/*
    Formez o secventa de lungime len care contine o subsecventa maxima
de lungime cel putin K.
    Variabila < C > este o constanta care imi spune ca pentru a forma o
subsecventa de lungime cel putin K pun K/2+rand()%C+1 elemente egale cu un
x fixat.
    Variabila < nr > imi spune ca in secventa de lungime len mai adaug < nr >
aparitii ale lui x.
*/
void baga(int len, int K, int C, int nr)
{
    int i, j, k, x, p, q, r, s, t, cnt, start;

    for(i = 1; i <= len; i++)
        B[i] = 0;

    x = rand() % N + 1;

    cnt = K/2 + rand() % C + 1;
    start = rand() % (len-K+1) + 1;

    for(i = 1; i <= cnt; i++)
    {
        p = rand() % K;
        while(B[start+p])
            p = rand() % K;
        B[start+p] = x;
    }

    for(j = start; j <= start+K-1; j++)
     if(!B[j])
        B[j] = rand() % N + 1;

    for(i = 1; i <= nr; i++)
    {
        p = rand() % len + 1;
        while(B[p])
            p = rand() % len + 1;
        B[p] = x;
    }

    for(i = 1; i <= len; i++)
     if(!B[i])
        B[i] = rand() % N + 1;

    for(i = 1; i <= len; i++)
        A[++A[0]] = B[i];
}

int main(void)
{
    int i, j, k, q, p, r, t, P, len, K, C, nr;

    freopen("values.in", "r", stdin);

    srand((unsigned)time(0));

    for (int i = 0; i < 10; ++ i)
    {
    //  printf("N, Cate secvente contine sirul\n");
        scanf("%d %d", &N, &P);

        // Atentie, suma lungimilor secventei trebuie sa fie egala cu N
        // Cateva secvente ar fi de ajuns cred (3,4,5)
        memset(A, 0, sizeof(A));
        memset(B, 0, sizeof(B));
        for(j = 1; j <= P; j++)
        {
            // informatii despre fiecare secventa
        //  printf("Lungimea secventei, lungimea minima a unei subsecvente, constanta C, variabila nr\n");
            scanf("%d %d %d %d", &len, &K, &C, &nr);
            baga(len, K, C, nr);
        }

        ostringstream file;
        file << (i + 1) << "-mate.in";
        printf("%s\n", file.str().c_str());
        FILE *fo = fopen(file.str().c_str(), "wt");

        fprintf(fo, "%d\n", N);
        for(j = 1; j < N; j++)
            fprintf(fo, "%d ", A[j]);
        fprintf(fo, "%d\n", A[N]);
        fclose(fo);
    }

    return 0;
}














