#include <iostream>
#include <fstream>
#include <algorithm>
using namespace std;

const char iname[] = "mate.in";
const char oname[] = "mate.out";

const int MAX_N = 500005;

int S[MAX_N], n;

int candidate[MAX_N], freq[MAX_N];

int main(void)
{
    ifstream in(iname);
    in >> n;
    for (int i = 0; i < n; ++ i)
        in >> S[i];
    in.close();

    int res = 1;
    for (int i = 0; i < n; ++ i)
    {
        int val = -1;
        int cnt = 1;
        for (int j = i; j < n; ++ j)
        {
            if (val != S[j])
            {
                if ((-- cnt) == 0)
                    val = S[j], cnt = 1;
            }
            else
                cnt ++;
            candidate[j] = val;
        }
        for (int j = i; j < n; ++ j)
        {
            freq[S[j]] ++;
            if (freq[candidate[j]] >= (j-i+2) / 2)
                res = max(res, j-i+1);
        }
        for (int j = i; j < n; ++ j)
            freq[S[j]] --;
    }
    ofstream(oname) << res << "\n";

    return 0;
}
