#include <iostream>
#include <fstream>
#include <set>
#include <algorithm>
using namespace std;

const char iname[] = "mate.in";
const char oname[] = "mate.out";

const int MAX_N = 500005;

int A[MAX_N], n, frecv[MAX_N];

set < pair <int, int> > S;

int main(void)
{
    ifstream in(iname);
    in >> n;
    for (int i = 0; i < n; ++ i)
        in >> A[i];
    in.close();

    int res = 1;
    for (int i = 0; i < n; ++ i)
    {
        S.clear();
        for (int j = i; j < n; ++ j)
        {
            S.erase( make_pair(frecv[A[j]], A[j]) );
            frecv[A[j]] ++;
            S.insert( make_pair(frecv[A[j]], A[j]) );
            int bst = (*S.rbegin()).first;
            if (bst >= (j-i+2) / 2)
                res = max(res, j-i+1);
        }
        for (int j = i; j < n; ++ j)
            frecv[A[j]] --;
    }
    ofstream(oname) << res << "\n";

    return 0;
}
