program trotuarul;
const fin='trotuar.in';
      fout='trotuar.out';
      modulo=666013;
type sir=array[0..500] of int64;
     sirmare=array[0..100000] of int64;
var v,lat,k,m:int64;
    h,n:int64;
    distanta,distanta2,lung:longint;
    i,j,l,p:longint;
    x,y,a:sir;
    trotuar,trotuar1,trotuar2,lmic:sir;
    lmare:sirmare;
    f,g:text;
    latime, lungime,nrsol:int64;
procedure sortare1;    {sortare numere}
var i,j:longint;
    aux:int64;
begin
  for i:=1 to k-1 do
    for j:=i+1 to k do
      if a[i]>a[j] then
        begin
          aux:=a[i];
          a[i]:=a[j];
          a[j]:=aux;
        end;
end;

procedure sortare2;   {sortare coordonate de puncte}
var i,j:longint;
    aux:int64;
begin
  for i:=1 to m-1 do
    for j:=i+1 to m do
      if (x[i]>x[j]) or (x[i]=x[j]) and (y[i]>y[j]) then
        begin
          aux:=x[i];
          x[i]:=x[j];
          x[j]:=aux;
          aux:=y[i];
          y[i]:=y[j];
          y[j]:=aux;
        end;
end;

function putere(x:int64;n:int64):int64;
var p:int64;
begin
  if n=0 then putere:=1
  else
    begin
      p:=putere(x,n div 2);
      if odd(n) then
        putere:=((p*p) mod modulo*x) mod modulo
      else
        putere:=(p*p) mod modulo;
    end;
end;

procedure calcullmic;
begin
  lmic[0]:=1;
  for i:=1 to l do
    begin
      lmic[i]:=0;         {in cate moduri putem pava trotuarul de latime i}
      for j:=1 to k do       {cu dale cu dimesiuni date}
        begin
          if a[j]>i then break;
          lmic[i]:=(lmic[i]+lmic[i-a[j]]) mod modulo;
        end;
    end;
end;
procedure calcullmare;
begin
  lmare[0]:=1;
  for lung:=1 to l-1 do
    begin
      for p:=1 to k do
        begin
          if a[p]>lung then break;
          lmare[lung]:=(lmare[lung]+lmare[lung-a[p]]) mod modulo;
        end;
    end;
  for lung:=l to n do
    begin
      {pentru latime = l se pot pune si longitudinal si transversal}
      lmare[lung]:=(lmic[l]*lmare[lung-l]) mod modulo; {completare longitudinala}
      if a[k]=l then dec(lmare[lung],lmare[lung-l]);{daca avem piesa patratica
                      nu o vom numara si longitudinal, si transversal}
      for p:=1 to k do
        lmare[lung]:=(lmare[lung]+lmare[lung-a[p]]) mod modulo;
    end;
end;

begin
  assign(f,fin);
  reset(f);
  assign(g,fout);
  rewrite(g);
  readln(f,n,l,k,m);
  for i:=1 to k do
    read(f,a[i]);      {latimile dalelor}
  sortare1;
  for i:=1 to m do
    readln(f,x[i],y[i]);   {coordonatele gaurilor}
  x[m+1]:=n+1;
  sortare2;
  calcullmic;
  calcullmare;
  nrsol:=1;
  fillchar(trotuar1,sizeof(trotuar2),0);
  fillchar(trotuar2,sizeof(trotuar2),0);
  i:=1;
  latime:=l;
  while i<=m+1 do
    begin
      v:=x[i];
      trotuar2[y[i]]:=v;
      distanta:=trotuar2[y[i]]-trotuar1[y[i]]-1;
      i:=i+1;
      h:=1;
      while x[i]=v do
        begin
          trotuar2[y[i]]:=v;
          distanta2:=trotuar2[y[i]]-trotuar1[y[i]]-1;
          if distanta2<>distanta then
            nrsol:=0;
          lungime:=(v-trotuar1[y[i]]-1) div l;
          inc(i);
          inc(h);
        end;
      if nrsol<>0 then
        begin
          if latime=l then
            begin
              for j:=1 to l do
                if trotuar2[j]=0 then
                  trotuar2[j]:=v-1;
              nrsol:=(nrsol*lmare[distanta]) mod modulo;
              trotuar:=trotuar1;
              trotuar1:=trotuar2;
              fillchar(trotuar2,sizeof(trotuar2),0);
              latime:=h;
            end
          else
            begin
              latime:=1;
              lungime:=(v-trotuar1[1]) div l;
              if trotuar2[1]=0 then
                  trotuar2[1]:=trotuar1[1]+lungime*l;
              for j:=2 to l do
                  if trotuar1[j-1]=trotuar1[j] then
                    begin
                      inc(latime);
                      lungime:=(v-trotuar1[j]) div l;
                      if trotuar2[j]=0 then
                        trotuar2[j]:=trotuar1[j]+lungime*l;
                    end
                  else
                    begin
                      nrsol:=(nrsol*putere(lmic[latime],lungime)) mod modulo;
                      latime:=1;
                      lungime:=(v-trotuar1[j]) div l;
                      if trotuar2[j]=0 then
                        trotuar2[j]:=trotuar1[j]+lungime*l;
                    end;
              if latime=l then
                begin
                  nrsol:=(nrsol*lmare[v-trotuar1[1]-1]) mod modulo;
                  trotuar:=trotuar1;
                  fillchar(trotuar1,sizeof(trotuar1),0);
                  j:=i-1;
                  while (j>0) and (x[j]=v) do
                    begin
                      trotuar1[y[j]]:=v;
                      dec(j);
                    end;
                  for j:=1 to l do
                    if trotuar1[j]=0 then
                      trotuar1[j]:=v-1;
                  latime:=1;
                end
              else
                begin
                  nrsol:=(nrsol*putere(lmic[latime],lungime)) mod modulo;
                  trotuar:=trotuar1;
                  trotuar1:=trotuar2;
                end;
              fillchar(trotuar2,sizeof(trotuar2),0);
            end;
      end;
    end;
  writeln(g,nrsol);
  close(f);
  close(g);

end.
